Index: /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2.fcm	(revision 10099)
+++ /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2.fcm	(revision 10099)
@@ -0,0 +1,44 @@
+# POWER 6 at ECMWF
+#
+# NCDF_INC    netcdf4 include file
+# NCDF_LIB    netcdf4 library
+# XIOS_INC    xios include file    (taken into accound only if key_iomput is activated)
+# XIOS_LIB    xios library         (taken into accound only if key_iomput is activated)
+#
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make  
+# USER_INC    complete list of include files
+# USER_LIB    complete list of libraries to pass to the linker
+#
+# Note that:
+#  - unix variables "$..." are accpeted and will be evaluated before calling fcm.
+#  - fcm variables are starting with a % (and not a $)
+#
+#options:
+# debug: -g  -check bounds -check uninit -check pointers -traceback
+#
+%XIOS_LIB -L /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/lib -lxios
+%XIOS_INC -I /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/include
+%NCDF_INC            -I$NETCDF_INC
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+%CPP                 cpp
+%FC                  ftn
+##%FCFLAGS             -align array64byte -fp-model source -ftz -O2 -xAVX -finline-functions -finline-limit=500  -r8
+%FCFLAGS             -fp-model source -ftz -O2 -r8 -traceback
+#%FCFLAGS             -fp-model source -O1 -r8 -check bounds  -g -traceback -check pointers -check uninit -fpe-all=0 -ftz
+%FFLAGS              %FCFLAGS
+%LD                  ftn
+%FPPFLAGS            -P -C -traditional
+%LDFLAGS              -sox 
+%AR                  ar
+%ARFLAGS             -rs
+%MK                  gmake
+%USER_INC            %XIOS_INC %NCDF_INC
+%USER_LIB            %XIOS_LIB %NCDF_LIB -lstdc++
Index: /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2_bug.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2_bug.fcm	(revision 10099)
+++ /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-ifort_CRAY_CCA_XIO2_bug.fcm	(revision 10099)
@@ -0,0 +1,56 @@
+# POWER 6 at ECMWF
+#
+# NCDF_INC    netcdf4 include file
+# NCDF_LIB    netcdf4 library
+# XIOS_INC    xios include file    (taken into accound only if key_iomput is activated)
+# XIOS_LIB    xios library         (taken into accound only if key_iomput is activated)
+#
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make  
+# USER_INC    complete list of include files
+# USER_LIB    complete list of libraries to pass to the linker
+#
+# Note that:
+#  - unix variables "$..." are accpeted and will be evaluated before calling fcm.
+#  - fcm variables are starting with a % (and not a $)
+#
+#options:
+# debug: -g  -check bounds -check uninit -check pointers -traceback
+#
+
+
+#%FCFLAGS             -O2 -i4 -r8 -fp-model precise -convert big_endian -assume byterecl -g -traceback -check bounds -check uninit -check pointers
+#%FCFLAGS             -O2 -i4 -r8 -fp-model precise -convert big_endian -assume byterecl -g -traceback -ftrapuv -fpe0 -check bounds -check uninit -check pointers
+
+
+
+
+%XIOS_LIB -L /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/lib -lxios
+%XIOS_INC -I /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/include
+%NCDF_INC            -I$NETCDF_INC
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+%CPP                 cpp
+%FC                  ftn
+##%FCFLAGS             -align array64byte -fp-model source -ftz -O2 -xAVX -finline-functions -finline-limit=500  -r8
+#%FCFLAGS             -fp-model source -ftz -O2 -r8 -traceback
+#%FCFLAGS             -fp-model source -O1 -r8 -check bounds  -g -traceback -fpe-all=0
+#%FCFLAGS             -fp-model source -O1 -r8 -check bounds  -g -traceback -fpe3
+#%FCFLAGS             -fp-model source -O1 -r8 -check bounds  -g -traceback -ftrapuv 
+%FCFLAGS             -fp-model source -O0 -r8 -no-ftz -align array64byte  -finline-functions -finline-limit=500 -check bounds -g -traceback
+#%FCFLAGS             -fp-model source -O0 -r8 -no-ftz -align array64byte  -xAVX -finline-functions -finline-limit=500 -check bounds -g -traceback
+%FFLAGS              %FCFLAGS
+%LD                  ftn
+%FPPFLAGS            -P -C -traditional
+%LDFLAGS              -sox
+%AR                  ar
+%ARFLAGS             -rs
+%MK                  gmake
+%USER_INC            %XIOS_INC %NCDF_INC
+%USER_LIB            %XIOS_LIB %NCDF_LIB -lstdc++
Index: /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_KARA_MERCATOR_XIOS.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_KARA_MERCATOR_XIOS.fcm	(revision 10099)
+++ /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_KARA_MERCATOR_XIOS.fcm	(revision 10099)
@@ -0,0 +1,39 @@
+# ifort compiler options for linux
+# NCDF_INC    netcdf include file
+# NCDF_LIB    netcdf library
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make
+# USER_INC    additional include files for the compiler,  e.g. -I<include dir>
+# USER_LIB    additional libraries to pass to the linker, e.g. -l<library>
+# CC          C compiler used to compile conv for AGRIF
+# CFLAGS      compiler flags used with CC
+# debug: -g  -check bounds -check uninit -check pointers -traceback
+# #-xAVX
+#
+%NCDF_INC            -I$NETCDF_INC
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+
+%CPP	             cpp
+%FC                  mpif90 -fpp 
+# norep 156 %FCFLAGS             -i4 -r8 -O3 -fp-model precise
+# norep 156 %FCFLAGS             -i4 -r8 -O2 -fp-model precise
+%FCFLAGS             -i4 -r8 -O0 -fp-model precise
+%FFLAGS              %FCFLAGS
+%LD                   mpif90
+%FPPFLAGS            -P -traditional
+%LDFLAGS             -O2
+%AR                  ar
+%ARFLAGS             -rs
+%MK                  gmake
+%USER_INC            -I$XIOS_INC %NCDF_INC
+%USER_LIB            -L$XIOS_LIB -lxios %NCDF_LIB -lstdc++
+
+%CC                  cc
+%CFLAGS              -O0
Index: /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_NAVITI_MERCATOR.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_NAVITI_MERCATOR.fcm	(revision 10099)
+++ /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/MERCATOR/arch-openmpi_NAVITI_MERCATOR.fcm	(revision 10099)
@@ -0,0 +1,37 @@
+# ifort compiler options for linux
+# NCDF_INC    netcdf include file
+# NCDF_LIB    netcdf library
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make
+# USER_INC    additional include files for the compiler,  e.g. -I<include dir>
+# USER_LIB    additional libraries to pass to the linker, e.g. -l<library>
+# CC          C compiler used to compile conv for AGRIF
+# CFLAGS      compiler flags used with CC
+# debug: -g  -check bounds -check uninit -check pointers -traceback
+
+#
+%NCDF_INC            -I$NETCDF_INC
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+
+%CPP	             cpp
+%FC                  mpif90
+%FCFLAGS             -O1 -fp-model precise  -traceback -r8  -convert big_endian -assume byterecl
+%FFLAGS              %FCFLAGS
+%LD                   mpif90
+%FPPFLAGS            -P -C -traditional
+%LDFLAGS             -O2
+%AR                  ar
+%ARFLAGS             -rs
+%MK                  gmake
+%USER_INC            -I$XIOS_INC %NCDF_INC
+%USER_LIB            -L$XIOS_LIB -lxios %NCDF_LIB -lstdc++
+
+%CC                  cc
+%CFLAGS              -O0
Index: MO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/arch-ifort_CRAY_CCA_XIO2.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/arch-ifort_CRAY_CCA_XIO2.fcm	(revision 10098)
+++ 	(revision )
@@ -1,44 +1,0 @@
-# POWER 6 at ECMWF
-#
-# NCDF_INC    netcdf4 include file
-# NCDF_LIB    netcdf4 library
-# XIOS_INC    xios include file    (taken into accound only if key_iomput is activated)
-# XIOS_LIB    xios library         (taken into accound only if key_iomput is activated)
-#
-# FC          Fortran compiler command
-# FCFLAGS     Fortran compiler flags
-# FFLAGS      Fortran 77 compiler flags
-# LD          linker
-# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
-# FPPFLAGS    pre-processing flags
-# AR          assembler
-# ARFLAGS     assembler flags
-# MK          make  
-# USER_INC    complete list of include files
-# USER_LIB    complete list of libraries to pass to the linker
-#
-# Note that:
-#  - unix variables "$..." are accpeted and will be evaluated before calling fcm.
-#  - fcm variables are starting with a % (and not a $)
-#
-#options:
-# debug: -g  -check bounds -check uninit -check pointers -traceback
-#
-%XIOS_LIB -L /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/lib -lxios
-%XIOS_INC -I /perm/ms/fr/ar5/DEV/intel/xios_trunk_r930/include
-%NCDF_INC            -I$NETCDF_INC
-%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
-%CPP                 cpp
-%FC                  ftn
-##%FCFLAGS             -align array64byte -fp-model source -ftz -O2 -xAVX -finline-functions -finline-limit=500  -r8
-%FCFLAGS             -fp-model source -ftz -O2 -r8 -traceback
-#%FCFLAGS             -fp-model source -O1 -r8 -check bounds  -g -traceback -check pointers -check uninit -fpe-all=0 -ftz
-%FFLAGS              %FCFLAGS
-%LD                  ftn
-%FPPFLAGS            -P -C -traditional
-%LDFLAGS              -sox 
-%AR                  ar
-%ARFLAGS             -rs
-%MK                  gmake
-%USER_INC            %XIOS_INC %NCDF_INC
-%USER_LIB            %XIOS_LIB %NCDF_LIB -lstdc++
Index: MO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/arch-openmpi_NAVITI_MERCATOR.fcm
===================================================================
--- /NEMO/branches/2018/dev_r5003_MERCATOR6_CRS/NEMOGCM/ARCH/arch-openmpi_NAVITI_MERCATOR.fcm	(revision 10098)
+++ 	(revision )
@@ -1,37 +1,0 @@
-# ifort compiler options for linux
-# NCDF_INC    netcdf include file
-# NCDF_LIB    netcdf library
-# FC          Fortran compiler command
-# FCFLAGS     Fortran compiler flags
-# FFLAGS      Fortran 77 compiler flags
-# LD          linker
-# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
-# FPPFLAGS    pre-processing flags
-# AR          assembler
-# ARFLAGS     assembler flags
-# MK          make
-# USER_INC    additional include files for the compiler,  e.g. -I<include dir>
-# USER_LIB    additional libraries to pass to the linker, e.g. -l<library>
-# CC          C compiler used to compile conv for AGRIF
-# CFLAGS      compiler flags used with CC
-# debug: -g  -check bounds -check uninit -check pointers -traceback
-
-#
-%NCDF_INC            -I$NETCDF_INC
-%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
-
-%CPP	             cpp
-%FC                  mpif90
-%FCFLAGS             -O2 -fp-model precise  -traceback -r8  -convert big_endian -assume byterecl
-%FFLAGS              %FCFLAGS
-%LD                   mpif90
-%FPPFLAGS            -P -C -traditional
-%LDFLAGS             -O2
-%AR                  ar
-%ARFLAGS             -rs
-%MK                  gmake
-%USER_INC            -I$XIOS_INC %NCDF_INC
-%USER_LIB            -L$XIOS_LIB -lxios %NCDF_LIB -lstdc++
-
-%CC                  cc
-%CFLAGS              -O0