Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdf_oce.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdf_oce.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdf_oce.F90	(revision 10126)
@@ -54,5 +54,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$ 
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfddm.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfddm.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfddm.F90	(revision 10126)
@@ -34,5 +34,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfdrg.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfdrg.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfdrg.F90	(revision 10126)
@@ -76,5 +76,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: zdfdrg.F90 7753 2017-03-03 11:46:59Z gm $
+   !! $Id$
    !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfevd.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfevd.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfevd.F90	(revision 10126)
@@ -34,5 +34,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfgls.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfgls.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfgls.F90	(revision 10126)
@@ -108,5 +108,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfiwm.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfiwm.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfiwm.F90	(revision 10126)
@@ -52,5 +52,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: zdfiwm.F90 8093 2017-05-30 08:13:14Z gm $
+   !! $Id$
    !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfmxl.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfmxl.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfmxl.F90	(revision 10126)
@@ -38,5 +38,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$ 
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfosm.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfosm.F90	(revision 10126)
@@ -106,5 +106,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfphy.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfphy.F90	(revision 10126)
@@ -56,5 +56,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: zdfphy.F90 8160 2017-06-10 07:31:34Z gm $
+   !! $Id$
    !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfric.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfric.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfric.F90	(revision 10126)
@@ -54,5 +54,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfsh2.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfsh2.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfsh2.F90	(revision 10126)
@@ -23,5 +23,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: $
+   !! $Id$
    !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfswm.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfswm.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdfswm.F90	(revision 10126)
@@ -29,5 +29,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018) 
-   !! $Id:$
+   !! $Id$
    !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdftke.F90
===================================================================
--- NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdftke.F90	(revision 10058)
+++ NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/ZDF/zdftke.F90	(revision 10126)
@@ -93,5 +93,5 @@
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS