Index: /branches/UKMO/dev_r5518_obs_oper_update_keyfoammedusa/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/UKMO/dev_r5518_obs_oper_update_keyfoammedusa/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 10139)
+++ /branches/UKMO/dev_r5518_obs_oper_update_keyfoammedusa/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 10140)
@@ -888,5 +888,5 @@
       USE par_hadocc
       USE had_bgc_const, ONLY: c2n_p
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
       USE trc, ONLY :  &           ! MEDUSA variables
          & trn
@@ -985,5 +985,5 @@
                ! Chlorophyll from HadOCC
                zprofvar(:,:,:,1) = HADOCC_CHL(:,:,:)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Add non-diatom and diatom chlorophyll from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpchn) + trn(:,:,:,jpchd)
@@ -1023,5 +1023,5 @@
                ! Chlorophyll from HadOCC
                zprofvar(:,:,:,1) = HADOCC_CHL(:,:,:)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Add non-diatom and diatom chlorophyll from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpchn) + trn(:,:,:,jpchd)
@@ -1039,5 +1039,5 @@
                ! Dissolved inorganic nitrogen from HadOCC
                zprofvar(:,:,:,1) = trn(:,:,:,jp_had_nut)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Dissolved inorganic nitrogen from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpdin)
@@ -1054,5 +1054,5 @@
                CALL ctl_stop( ' Trying to run psi4 observation operator', &
                   &           ' but HadOCC does not simulate silicate' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Silicate from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpsil)
@@ -1069,5 +1069,5 @@
                CALL ctl_stop( ' Trying to run ppo4 observation operator', &
                   &           ' but HadOCC does not simulate phosphate' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                CALL ctl_stop( ' Trying to run ppo4 observation operator', &
                   &           ' but MEDUSA does not simulate phosphate' )
@@ -1084,5 +1084,5 @@
                ! Dissolved inorganic carbon from HadOCC
                zprofvar(:,:,:,1) = trn(:,:,:,jp_had_dic)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Dissolved inorganic carbon from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpdic)
@@ -1099,5 +1099,5 @@
                ! Alkalinity from HadOCC
                zprofvar(:,:,:,1) = trn(:,:,:,jp_had_alk)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Alkalinity from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpalk)
@@ -1114,5 +1114,5 @@
                CALL ctl_stop( ' Trying to run pph observation operator', &
                   &           ' but HadOCC has no pH diagnostic defined' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa && defined key_roam
                ! pH from MEDUSA
                zprofvar(:,:,:,1) = f3_pH(:,:,:)
@@ -1129,5 +1129,5 @@
                CALL ctl_stop( ' Trying to run po2 observation operator', &
                   &           ' but HadOCC does not simulate oxygen' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Oxygen from MEDUSA
                zprofvar(:,:,:,1) = trn(:,:,:,jpoxy)
@@ -1210,5 +1210,5 @@
                ! Surface chlorophyll from HadOCC
                zsurfvar(:,:) = HADOCC_CHL(:,:,1)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Add non-diatom and diatom surface chlorophyll from MEDUSA
                zsurfvar(:,:) = trn(:,:,1,jpchn) + trn(:,:,1,jpchd)
@@ -1227,5 +1227,5 @@
                CALL ctl_stop( ' Trying to run slchldia observation operator', &
                   &           ' but HadOCC does not explicitly simulate diatoms' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Diatom surface chlorophyll from MEDUSA
                zsurfvar(:,:) = trn(:,:,1,jpchd)
@@ -1243,5 +1243,5 @@
                CALL ctl_stop( ' Trying to run slchlnon observation operator', &
                   &           ' but HadOCC does not explicitly simulate non-diatoms' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Non-diatom surface chlorophyll from MEDUSA
                zsurfvar(:,:) = trn(:,:,1,jpchn)
@@ -1260,5 +1260,5 @@
                CALL ctl_stop( ' Trying to run slchldin observation operator', &
                   &           ' but HadOCC does not explicitly simulate dinoflagellates' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                CALL ctl_stop( ' Trying to run slchldin observation operator', &
                   &           ' but MEDUSA does not explicitly simulate dinoflagellates' )
@@ -1276,5 +1276,5 @@
                CALL ctl_stop( ' Trying to run slchlmic observation operator', &
                   &           ' but HadOCC does not explicitly simulate microphytoplankton' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                CALL ctl_stop( ' Trying to run slchlmic observation operator', &
                   &           ' but MEDUSA does not explicitly simulate microphytoplankton' )
@@ -1292,5 +1292,5 @@
                CALL ctl_stop( ' Trying to run slchlnan observation operator', &
                   &           ' but HadOCC does not explicitly simulate nanophytoplankton' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                CALL ctl_stop( ' Trying to run slchlnan observation operator', &
                   &           ' but MEDUSA does not explicitly simulate nanophytoplankton' )
@@ -1308,5 +1308,5 @@
                CALL ctl_stop( ' Trying to run slchlpic observation operator', &
                   &           ' but HadOCC does not explicitly simulate picophytoplankton' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                CALL ctl_stop( ' Trying to run slchlpic observation operator', &
                   &           ' but MEDUSA does not explicitly simulate picophytoplankton' )
@@ -1324,5 +1324,5 @@
                ! Surface chlorophyll from HadOCC
                zsurfvar(:,:) = HADOCC_CHL(:,:,1)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Add non-diatom and diatom surface chlorophyll from MEDUSA
                zsurfvar(:,:) = trn(:,:,1,jpchn) + trn(:,:,1,jpchd)
@@ -1340,5 +1340,5 @@
                ! Surface phytoplankton nitrogen from HadOCC multiplied by C:N ratio
                zsurfvar(:,:) = trn(:,:,1,jp_had_phy) * c2n_p
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Add non-diatom and diatom surface phytoplankton nitrogen from MEDUSA
                ! multiplied by C:N ratio for each
@@ -1358,5 +1358,5 @@
                CALL ctl_stop( ' Trying to run slphydia observation operator', &
                   &           ' but HadOCC does not explicitly simulate diatoms' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Diatom surface phytoplankton nitrogen from MEDUSA multiplied by C:N ratio
                zsurfvar(:,:) = trn(:,:,1,jpphd) * xthetapd
@@ -1374,5 +1374,5 @@
                CALL ctl_stop( ' Trying to run slphynon observation operator', &
                   &           ' but HadOCC does not explicitly simulate non-diatoms' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                ! Non-diatom surface phytoplankton nitrogen from MEDUSA multiplied by C:N ratio
                zsurfvar(:,:) = trn(:,:,1,jpphn) * xthetapn
@@ -1408,5 +1408,5 @@
                      &           ' as HADOCC_FCO2(:,:) == HADOCC_FILL_FLT' )
                ENDIF
-#elif defined key_medusa && defined key_foam_medusa && defined key_roam
+#elif defined key_medusa && defined key_roam
                zsurfvar(:,:) = f2_fco2w(:,:)
 #elif defined key_fabm
@@ -1448,5 +1448,5 @@
                      &           ' as HADOCC_PCO2(:,:) == HADOCC_FILL_FLT' )
                ENDIF
-#elif defined key_medusa && defined key_foam_medusa && defined key_roam
+#elif defined key_medusa && defined key_roam
                zsurfvar(:,:) = f2_pco2w(:,:)
 #elif defined key_fabm