Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10077)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10141)
@@ -10,5 +10,4 @@
    !! 'key_hadocc'          : HadOCC model
    !! 'key_medusa'          : MEDUSA model
-   !! 'key_foam_medusa'     : MEDUSA extras for FOAM OBS and ASM
    !! 'key_roam'            : MEDUSA extras for carbonate cycle
    !! 'key_karaml'          : Kara mixed layer depth
@@ -56,5 +55,5 @@
       & jptra
 #endif
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
    USE asmphyto2dbal_medusa, ONLY: & ! phyto2d balancing for MEDUSA
       & asm_phyto2d_bal_medusa
@@ -161,12 +160,9 @@
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: pph_bkginc      ! pph inc
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: po2_bkginc      ! po2 inc
-#if defined key_top
    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: phyto2d_balinc  ! Balancing incs from ocean colour
    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: phyto3d_balinc  ! Balancing incs from p(l)chltot
    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: pco2_balinc     ! Balancing incs from spco2/sfco2
    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: ph_balinc       ! Balancing incs from pph
-#endif
-
-#if defined key_hadocc || (defined key_medusa && defined key_foam_medusa)
+
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: pgrow_avg_bkg   ! Background phyto growth
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: ploss_avg_bkg   ! Background phyto loss
@@ -174,9 +170,6 @@
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: mld_max_bkg     ! Background max MLD
    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: tracer_bkg      ! Background tracer state
-#endif
-#if defined key_hadocc
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: chl_bkg         ! Background chl
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: cchl_p_bkg      ! Background c:chl
-#endif
 
 #  include "domzgr_substitute.h90"
@@ -197,5 +190,5 @@
       !!------------------------------------------------------------------------
 
-#if ! defined key_top || ( ! defined key_hadocc && ( ! defined key_medusa || ! defined key_foam_medusa ) )
+#if ! defined key_top || ( ! defined key_hadocc && ! defined key_medusa )
       CALL ctl_stop( ' Attempting to assimilate biogeochemical observations', &
          &           ' but no compatible biogeochemical model is available' )
@@ -206,4 +199,10 @@
          & ln_slphynoninc .OR. ln_psi4inc .OR. ln_pphinc .OR. ln_po2inc ) THEN
          CALL ctl_stop( ' Cannot assimilate PFTs, Si4, pH or O2 into HadOCC' )
+      ENDIF
+#endif
+
+#if defined key_medusa
+      IF ( .NOT. ln_foam_medusa ) THEN
+         CALL ctl_stop( ' MEDUSA data assimilation options not turned on: set ln_foam_medusa' )
       ENDIF
 #endif
@@ -517,5 +516,5 @@
       !!------------------------------------------------------------------------
 
-#if defined key_top && ( defined key_hadocc || (defined key_medusa && defined key_foam_medusa) )
+#if defined key_top && ( defined key_hadocc || defined key_medusa )
       IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
          & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
@@ -552,5 +551,5 @@
          chl_bkg(:,:,:)    = chl_bkg(:,:,:)    * tmask(:,:,:)
          cchl_p_bkg(:,:,:) = cchl_p_bkg(:,:,:) * tmask(:,:,:)
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
          CALL iom_get( inum, jpdom_autoglo, 'medusa_chn', tracer_bkg(:,:,:,jpchn) )
          CALL iom_get( inum, jpdom_autoglo, 'medusa_chd', tracer_bkg(:,:,:,jpchd) )
@@ -578,5 +577,5 @@
             CALL iom_get( inum, jpdom_autoglo, 'hadocc_dic', tracer_bkg(:,:,:,jp_had_dic) )
             CALL iom_get( inum, jpdom_autoglo, 'hadocc_alk', tracer_bkg(:,:,:,jp_had_alk) )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             CALL iom_get( inum, jpdom_autoglo, 'medusa_zmi', tracer_bkg(:,:,:,jpzmi) )
             CALL iom_get( inum, jpdom_autoglo, 'medusa_zme', tracer_bkg(:,:,:,jpzme) )
@@ -594,5 +593,5 @@
             CALL iom_get( inum, jpdom_autoglo, 'hadocc_dic', tracer_bkg(:,:,:,jp_had_dic) )
             CALL iom_get( inum, jpdom_autoglo, 'hadocc_alk', tracer_bkg(:,:,:,jp_had_alk) )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             CALL iom_get( inum, jpdom_autoglo, 'medusa_dic', tracer_bkg(:,:,:,jpdic) )
             CALL iom_get( inum, jpdom_autoglo, 'medusa_alk', tracer_bkg(:,:,:,jpalk) )
@@ -620,5 +619,5 @@
          CALL iom_get( inum, jpdom_autoglo, 'hadocc_dic', tracer_bkg(:,:,:,jp_had_dic) )
          CALL iom_get( inum, jpdom_autoglo, 'hadocc_alk', tracer_bkg(:,:,:,jp_had_alk) )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
          CALL iom_get( inum, jpdom_autoglo, 'medusa_dic', tracer_bkg(:,:,:,jpdic) )
          CALL iom_get( inum, jpdom_autoglo, 'medusa_alk', tracer_bkg(:,:,:,jpalk) )
@@ -690,5 +689,5 @@
             & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
             & ln_slphynoninc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             CALL iom_rstput( kt, kt, inum, 'phy2d_chn', phyto2d_balinc(:,:,:,jpchn) )
             CALL iom_rstput( kt, kt, inum, 'phy2d_chd', phyto2d_balinc(:,:,:,jpchd) )
@@ -721,5 +720,5 @@
 
          IF ( ln_plchltotinc .OR. ln_pchltotinc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             CALL iom_rstput( kt, kt, inum, 'phy3d_chn', phyto3d_balinc(:,:,:,jpchn) )
             CALL iom_rstput( kt, kt, inum, 'phy3d_chd', phyto3d_balinc(:,:,:,jpchd) )
@@ -733,5 +732,5 @@
 
          IF ( ln_spco2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             CALL iom_rstput( kt, kt, inum, 'pco2_dic', pco2_balinc(:,:,:,jpdic) )
             CALL iom_rstput( kt, kt, inum, 'pco2_alk', pco2_balinc(:,:,:,jpalk) )
@@ -741,5 +740,5 @@
 #endif
          ELSE IF ( ln_sfco2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             CALL iom_rstput( kt, kt, inum, 'fco2_dic', pco2_balinc(:,:,:,jpdic) )
             CALL iom_rstput( kt, kt, inum, 'fco2_alk', pco2_balinc(:,:,:,jpalk) )
@@ -751,5 +750,5 @@
 
          IF ( ln_pphinc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             CALL iom_rstput( kt, kt, inum, 'ph_dic', ph_balinc(:,:,:,jpdic) )
             CALL iom_rstput( kt, kt, inum, 'ph_alk', ph_balinc(:,:,:,jpalk) )
@@ -806,5 +805,5 @@
       CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_chl'  , HADOCC_CHL(:,:,:)     )
       CALL iom_rstput( kt, nitbkg_r, knum, 'hadocc_cchl' , cchl_p(:,:,:)         )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
       CALL iom_rstput( kt, nitbkg_r, knum, 'pgrow_avg'   , pgrow_avg        )
       CALL iom_rstput( kt, nitbkg_r, knum, 'ploss_avg'   , ploss_avg        )
@@ -904,5 +903,5 @@
       REAL(wp), DIMENSION(jpi,jpj) :: zinc_phytot ! Local phytot incs
       REAL(wp), DIMENSION(jpi,jpj) :: zbkg_phytot ! Local phytot bkg
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
       REAL(wp), DIMENSION(jpi,jpj) :: zinc_chldia ! Local chldia incs
       REAL(wp), DIMENSION(jpi,jpj) :: zbkg_chldia ! Local chldia bkg
@@ -924,5 +923,5 @@
          ! Total chlorophyll
          IF ( ln_slchltotinc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             zbkg_chltot(:,:) = tracer_bkg(:,:,1,jpchn) + tracer_bkg(:,:,1,jpchd)
 #elif defined key_hadocc
@@ -936,5 +935,5 @@
          ENDIF
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Diatom chlorophyll
          IF ( ln_slchldiainc ) THEN
@@ -946,5 +945,5 @@
 #endif
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Non-diatom chlorophyll
          IF ( ln_slchlnoninc ) THEN
@@ -958,5 +957,5 @@
          ! Total phytoplankton carbon
          IF ( ln_slphytotinc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             zbkg_phytot(:,:) = (trn(:,:,1,jpphn) * xthetapn) + (trn(:,:,1,jpphd) * xthetapd)
 #elif defined key_hadocc
@@ -968,5 +967,5 @@
          ENDIF
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Diatom phytoplankton carbon
          IF ( ln_slphydiainc ) THEN
@@ -978,5 +977,5 @@
 #endif
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Non-diatom phytoplankton carbon
          IF ( ln_slphynoninc ) THEN
@@ -990,5 +989,5 @@
          ! Select mixed layer
          IF ( ll_asmdin ) THEN
-#if defined key_top && ( defined key_hadocc || (defined key_medusa && defined key_foam_medusa) )
+#if defined key_top && ( defined key_hadocc || defined key_medusa )
             CALL ctl_warn( ' Doing direct initialisation with ocean colour assimilation', &
                &           ' Mixed layer depth taken to be background maximum mld_max_bkg' )
@@ -1026,5 +1025,5 @@
          zincper = (nitiaufin_r - nitiaustr_r + 1) * rdt
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          CALL asm_phyto2d_bal_medusa( (ln_slchltotinc .OR. ln_schltotinc), &
             &                         zinc_chltot,                         &
@@ -1084,5 +1083,5 @@
             ! Add directly to trn and trb, rather than to tra, because tra gets
             ! reset to zero at the start of trc_stp, called after this routine
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( phyto2d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + phyto2d_balinc(:,:,:,jp_msa0:jp_msa1) * zincwgt > 0.0_wp )
@@ -1120,5 +1119,5 @@
             CALL ctl_warn( ' Doing direct initialisation with phyto2d assimilation', &
                &           ' Background state is taken from model rather than background file' )
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( phyto2d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + phyto2d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp )
@@ -1187,5 +1186,5 @@
             ! 3) Subtract background from analysis to get chl incs
             ! If rn_maxchlinc > 0 then cap total absolute chlorophyll increment at that value
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             bkg_chl(:,:,:) = tracer_bkg(:,:,:,jpchn) + tracer_bkg(:,:,:,jpchd)
 #elif defined key_hadocc
@@ -1220,5 +1219,5 @@
          ENDIF
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Loop over each grid point partioning the increments based on existing ratios
          DO jk = 1, jpk
@@ -1271,5 +1270,5 @@
             ! Add directly to trn and trb, rather than to tra, because tra gets
             ! reset to zero at the start of trc_stp, called after this routine
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( phyto3d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + phyto3d_balinc(:,:,:,jp_msa0:jp_msa1) * zincwgt > 0.0_wp )
@@ -1307,5 +1306,5 @@
             CALL ctl_warn( ' Doing direct initialisation with phyto3d assimilation', &
                &           ' Background state is taken from model rather than background file' )
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( phyto3d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + phyto3d_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp )
@@ -1388,5 +1387,5 @@
 
          IF ( ln_sfco2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa && defined key_roam
+#if defined key_medusa && defined key_roam
             ! If assimilating fCO2, then convert to pCO2 using MEDUSA MOCSY subroutine
             patm(1) = 1.0
@@ -1421,5 +1420,5 @@
          ENDIF
 
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
          ! Account for phytoplankton balancing if required
          IF ( ln_phytobal ) THEN
@@ -1456,5 +1455,5 @@
          ! Select mixed layer
          IF ( ll_asmdin ) THEN
-#if defined key_hadocc || (defined key_medusa && defined key_foam_medusa)
+#if defined key_hadocc || defined key_medusa
             CALL ctl_warn( ' Doing direct initialisation with pCO2 assimilation', &
                &           ' Mixed layer depth taken to be background maximum mld_max_bkg' )
@@ -1541,5 +1540,5 @@
             ! Add directly to trn and trb, rather than to tra, because tra gets
             ! reset to zero at the start of trc_stp, called after this routine
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( pco2_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + pco2_balinc(:,:,:,jp_msa0:jp_msa1) * zincwgt > 0.0_wp )
@@ -1578,5 +1577,5 @@
             CALL ctl_warn( ' Doing direct initialisation with pCO2 assimilation', &
                &           ' Background state is taken from model rather than background file' )
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             WHERE( pco2_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp .OR. &
                &   trn(:,:,:,jp_msa0:jp_msa1) + pco2_balinc(:,:,:,jp_msa0:jp_msa1) > 0.0_wp )
@@ -1649,5 +1648,5 @@
       !!------------------------------------------------------------------------
 
-#if ! (defined key_medusa && defined key_foam_medusa)
+#if ! defined key_medusa
       CALL ctl_stop( ' pH balancing only implemented for MEDUSA' )
 #else
@@ -1858,8 +1857,8 @@
 
          IF ( ln_pno3inc ) THEN
-#if defined key_hadocc || ( defined key_medusa && defined key_foam_medusa )
+#if defined key_hadocc || defined key_medusa
 #if defined key_hadocc
             it = jp_had_nut
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             it = jpdin
 #endif
@@ -1882,5 +1881,5 @@
 
          IF ( ln_psi4inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             it = jpsil
             IF ( ln_phytobal ) THEN
@@ -1902,8 +1901,8 @@
 
          IF ( ln_pdicinc ) THEN
-#if defined key_hadocc || ( defined key_medusa && defined key_foam_medusa )
+#if defined key_hadocc || defined key_medusa
 #if defined key_hadocc
             it = jp_had_dic
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             it = jpdic
 #endif
@@ -1926,8 +1925,8 @@
 
          IF ( ln_palkinc ) THEN
-#if defined key_hadocc || ( defined key_medusa && defined key_foam_medusa )
+#if defined key_hadocc || defined key_medusa
 #if defined key_hadocc
             it = jp_had_alk
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             it = jpalk
 #endif
@@ -1950,5 +1949,5 @@
 
          IF ( ln_po2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
             it = jpoxy
             IF ( ln_phytobal ) THEN
@@ -2002,5 +2001,5 @@
                   trb(:,:,:,jp_had_nut) = trb(:,:,:,jp_had_nut) + pno3_bkginc(:,:,:) * zincwgt
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( pno3_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpdin) + pno3_bkginc(:,:,:) * zincwgt > 0.0_wp )
@@ -2014,5 +2013,5 @@
 
             IF ( ln_psi4inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
                WHERE( psi4_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpsil) + psi4_bkginc(:,:,:) * zincwgt > 0.0_wp )
@@ -2032,5 +2031,5 @@
                   trb(:,:,:,jp_had_dic) = trb(:,:,:,jp_had_dic) + pdic_bkginc(:,:,:) * zincwgt
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( pdic_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpdic) + pdic_bkginc(:,:,:) * zincwgt > 0.0_wp )
@@ -2050,5 +2049,5 @@
                   trb(:,:,:,jp_had_alk) = trb(:,:,:,jp_had_alk) + palk_bkginc(:,:,:) * zincwgt
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( palk_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpalk) + palk_bkginc(:,:,:) * zincwgt > 0.0_wp )
@@ -2062,5 +2061,5 @@
 
             IF ( ln_po2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
                WHERE( po2_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpoxy) + po2_bkginc(:,:,:) * zincwgt > 0.0_wp )
@@ -2098,5 +2097,5 @@
             CALL ctl_warn( ' Doing direct initialisation of HadOCC with 3D BGC assimilation', &
                &           ' Background state is taken from model rather than background file' )
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
             CALL ctl_warn( ' Doing direct initialisation of MEDUSA with 3D BGC assimilation', &
                &           ' Background state is taken from model rather than background file' )
@@ -2110,5 +2109,5 @@
                   trb(:,:,:,jp_had_nut) = trn(:,:,:,jp_had_nut)
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( pno3_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpdin) + pno3_bkginc(:,:,:) > 0.0_wp )
@@ -2122,5 +2121,5 @@
 
             IF ( ln_psi4inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
                WHERE( psi4_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpsil) + psi4_bkginc(:,:,:) > 0.0_wp )
@@ -2140,5 +2139,5 @@
                   trb(:,:,:,jp_had_dic) = trn(:,:,:,jp_had_dic)
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( pdic_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpdic) + pdic_bkginc(:,:,:) > 0.0_wp )
@@ -2158,5 +2157,5 @@
                   trb(:,:,:,jp_had_alk) = trn(:,:,:,jp_had_alk)
                END WHERE
-#elif defined key_medusa && defined key_foam_medusa
+#elif defined key_medusa
                WHERE( palk_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpalk) + palk_bkginc(:,:,:) > 0.0_wp )
@@ -2170,5 +2169,5 @@
 
             IF ( ln_po2inc ) THEN
-#if defined key_medusa && defined key_foam_medusa
+#if defined key_medusa
                WHERE( po2_bkginc(:,:,:) > 0.0_wp .OR. &
                   &   trn(:,:,:,jpoxy) + po2_bkginc(:,:,:) > 0.0_wp )
Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmphyto2dbal_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmphyto2dbal_medusa.F90	(revision 10077)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc_v3/NEMOGCM/NEMO/OPA_SRC/ASM/asmphyto2dbal_medusa.F90	(revision 10141)
@@ -12,9 +12,8 @@
    !! History :  3.6  ! 2017-08 (D. Ford)  Adapted from asmphyto2dbal_hadocc
    !!----------------------------------------------------------------------
-#if defined key_asminc && defined key_medusa && defined key_foam_medusa
+#if defined key_asminc && defined key_medusa
    !!----------------------------------------------------------------------
    !! 'key_asminc'          : assimilation increment interface
    !! 'key_medusa'          : MEDUSA model
-   !! 'key_foam_medusa'     : MEDUSA extras for FOAM OBS and ASM
    !!----------------------------------------------------------------------
    !! asm_phyto2d_bal_medusa : routine to calculate increments to MEDUSA